/*
CVE Services API

The CVE Services API supports automation tooling for the CVE Program. Credentials are     required for most service endpoints. Representatives of     <a href='https://www.cve.org/ProgramOrganization/CNAs'>CVE Numbering Authorities (CNAs)</a> should     use one of the methods below to obtain credentials:    <ul><li>If your organization already has an Organizational Administrator (OA) account for the CVE     Services, ask your admin for credentials</li>     <li>Contact your Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/Google'>Google</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/INCIBE'>INCIBE</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/jpcert'>JPCERT/CC</a>, or     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/redhat'>Red Hat</a>) or     Top-Level Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/icscert'>CISA ICS</a>     or <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/mitre'>MITRE</a>) to request credentials     </ul>     <p>CVE data is to be in the JSON 5.0 CVE Record format. Details of the JSON 5.0 schema are     located <a href='https://github.com/CVEProject/cve-schema/tree/master/schema/v5.0' target='_blank'>here</a>.</p>    <a href='https://cveform.mitre.org/' class='link' target='_blank'>Contact the CVE Services team</a>

API version: 2.1.4
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package cveapi

import (
	"encoding/json"
)

// checks if the CreateCveIdsPartialResponseDetails type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CreateCveIdsPartialResponseDetails{}

// CreateCveIdsPartialResponseDetails struct for CreateCveIdsPartialResponseDetails
type CreateCveIdsPartialResponseDetails struct {
	// The quantity of IDs reserved in the system
	AmountReserved *int32 `json:"amount_reserved,omitempty"`
}

// NewCreateCveIdsPartialResponseDetails instantiates a new CreateCveIdsPartialResponseDetails object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCreateCveIdsPartialResponseDetails() *CreateCveIdsPartialResponseDetails {
	this := CreateCveIdsPartialResponseDetails{}
	return &this
}

// NewCreateCveIdsPartialResponseDetailsWithDefaults instantiates a new CreateCveIdsPartialResponseDetails object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCreateCveIdsPartialResponseDetailsWithDefaults() *CreateCveIdsPartialResponseDetails {
	this := CreateCveIdsPartialResponseDetails{}
	return &this
}

// GetAmountReserved returns the AmountReserved field value if set, zero value otherwise.
func (o *CreateCveIdsPartialResponseDetails) GetAmountReserved() int32 {
	if o == nil || IsNil(o.AmountReserved) {
		var ret int32
		return ret
	}
	return *o.AmountReserved
}

// GetAmountReservedOk returns a tuple with the AmountReserved field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateCveIdsPartialResponseDetails) GetAmountReservedOk() (*int32, bool) {
	if o == nil || IsNil(o.AmountReserved) {
		return nil, false
	}
	return o.AmountReserved, true
}

// HasAmountReserved returns a boolean if a field has been set.
func (o *CreateCveIdsPartialResponseDetails) HasAmountReserved() bool {
	if o != nil && !IsNil(o.AmountReserved) {
		return true
	}

	return false
}

// SetAmountReserved gets a reference to the given int32 and assigns it to the AmountReserved field.
func (o *CreateCveIdsPartialResponseDetails) SetAmountReserved(v int32) {
	o.AmountReserved = &v
}

func (o CreateCveIdsPartialResponseDetails) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CreateCveIdsPartialResponseDetails) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.AmountReserved) {
		toSerialize["amount_reserved"] = o.AmountReserved
	}
	return toSerialize, nil
}

type NullableCreateCveIdsPartialResponseDetails struct {
	value *CreateCveIdsPartialResponseDetails
	isSet bool
}

func (v NullableCreateCveIdsPartialResponseDetails) Get() *CreateCveIdsPartialResponseDetails {
	return v.value
}

func (v *NullableCreateCveIdsPartialResponseDetails) Set(val *CreateCveIdsPartialResponseDetails) {
	v.value = val
	v.isSet = true
}

func (v NullableCreateCveIdsPartialResponseDetails) IsSet() bool {
	return v.isSet
}

func (v *NullableCreateCveIdsPartialResponseDetails) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCreateCveIdsPartialResponseDetails(val *CreateCveIdsPartialResponseDetails) *NullableCreateCveIdsPartialResponseDetails {
	return &NullableCreateCveIdsPartialResponseDetails{value: val, isSet: true}
}

func (v NullableCreateCveIdsPartialResponseDetails) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCreateCveIdsPartialResponseDetails) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


